diff --git a/test_plans/loopback_multi_paths_port_restart_test_plan.rst b/test_plans/loopback_multi_paths_port_restart_test_plan.rst
index d9a8d304..8418996b 100644
--- a/test_plans/loopback_multi_paths_port_restart_test_plan.rst
+++ b/test_plans/loopback_multi_paths_port_restart_test_plan.rst
@@ -420,7 +420,7 @@ Test Case 10: loopback test with packed ring vectorized path
 
 2. Launch virtio-user by below command::
 
-    ./testpmd -n 4 -l 5-6 --no-pci --file-prefix=virtio \
+    ./testpmd -n 4 -l 5-6 --no-pci --file-prefix=virtio --force-max-simd-bitwidth=512 \
     --vdev=net_virtio_user0,mac=00:01:02:03:04:05,path=./vhost-net,packed_vq=1,in_order=0,mrg_rxbuf=0,vectorized=1 \
     -- -i --nb-cores=1 --txd=1024 --rxd=1024
     >set fwd mac
@@ -446,4 +446,4 @@ Test Case 10: loopback test with packed ring vectorized path
     testpmd>port start 0
     testpmd>set burst 1
     testpmd>start tx_first 1
-    testpmd>show port stats all
\ No newline at end of file
+    testpmd>show port stats all
diff --git a/test_plans/loopback_multi_queues_test_plan.rst b/test_plans/loopback_multi_queues_test_plan.rst
index 0cea2b11..3d2851b8 100644
--- a/test_plans/loopback_multi_queues_test_plan.rst
+++ b/test_plans/loopback_multi_queues_test_plan.rst
@@ -591,7 +591,7 @@ Test Case 10: loopback with virtio 1.1 vectorized path using 1 queue and 8 queue
 2. Launch virtio-user by below command::
 
     ./testpmd -n 4 -l 5-6 \
-    --no-pci --file-prefix=virtio \
+    --no-pci --file-prefix=virtio --force-max-simd-bitwidth=512 \
     --vdev=net_virtio_user0,mac=00:01:02:03:04:05,path=./vhost-net,queues=1,packed_vq=1,mrg_rxbuf=0,in_order=1,vectorized=1 \
     -- -i --nb-cores=1 --txd=1024 --rxd=1024
     testpmd>set fwd mac
@@ -622,7 +622,7 @@ Test Case 10: loopback with virtio 1.1 vectorized path using 1 queue and 8 queue
 7. Launch virtio-user by below command::
 
     ./testpmd -n 4 -l 10-18 \
-    --no-pci --file-prefix=virtio \
+    --no-pci --file-prefix=virtio --force-max-simd-bitwidth=512 \
     --vdev=net_virtio_user0,mac=00:01:02:03:04:05,path=./vhost-net,queues=8,packed_vq=1,mrg_rxbuf=0,in_order=1,vectorized=1 \
     -- -i --nb-cores=8 --rxq=8 --txq=8 --txd=1024 --rxd=1024
     testpmd>set fwd mac
@@ -635,4 +635,4 @@ Test Case 10: loopback with virtio 1.1 vectorized path using 1 queue and 8 queue
 
 9. Get throughput 10 times and calculate the average throughput，check the throughput of 8 queues is eight times of 1 queue::
 
-    testpmd>show port stats all
\ No newline at end of file
+    testpmd>show port stats all
diff --git a/test_plans/loopback_virtio_user_server_mode_test_plan.rst b/test_plans/loopback_virtio_user_server_mode_test_plan.rst
index f30e3a55..18d580f4 100644
--- a/test_plans/loopback_virtio_user_server_mode_test_plan.rst
+++ b/test_plans/loopback_virtio_user_server_mode_test_plan.rst
@@ -742,7 +742,7 @@ Test Case 12: loopback reconnect test with packed ring vectorized path and serve
 
 2. Launch virtio-user as server mode with 2 queues::
 
-    ./testpmd -n 4 -l 5-7 --log-level=pmd.net.virtio.driver,8 --no-pci --file-prefix=virtio \
+    ./testpmd -n 4 -l 5-7 --log-level=pmd.net.virtio.driver,8 --no-pci --file-prefix=virtio --force-max-simd-bitwidth=512 \
     --vdev=net_virtio_user0,mac=00:01:02:03:04:05,path=./vhost-net,server=1,queues=2,packed_vq=1,mrg_rxbuf=0,in_order=1,vectorized=1 \
     -- -i --tx-offloads=0x0 --enable-hw-vlan-strip --rss-ip --nb-cores=2 --rxq=2 --txq=2
     >set fwd mac
@@ -777,7 +777,7 @@ Test Case 12: loopback reconnect test with packed ring vectorized path and serve
 
 8. Relaunch virtio-user and send packets::
 
-    ./testpmd -n 4 -l 5-7 --no-pci --file-prefix=virtio \
+    ./testpmd -n 4 -l 5-7 --no-pci --file-prefix=virtio --force-max-simd-bitwidth=512 \
     --vdev=net_virtio_user0,mac=00:01:02:03:04:05,path=./vhost-net,server=1,queues=2,packed_vq=1,mrg_rxbuf=0,in_order=1,vectorized=1 \
     -- -i --tx-offloads=0x0 --enable-hw-vlan-strip --rss-ip --nb-cores=2 --rxq=2 --txq=2
     >set fwd mac
@@ -799,4 +799,4 @@ Test Case 12: loopback reconnect test with packed ring vectorized path and serve
 
 11. Check each RX/TX queue has packets::
 
-     testpmd>stop
\ No newline at end of file
+     testpmd>stop
diff --git a/test_plans/perf_virtio_user_loopback_test_plan.rst b/test_plans/perf_virtio_user_loopback_test_plan.rst
index 11514dd8..b1b24e7f 100644
--- a/test_plans/perf_virtio_user_loopback_test_plan.rst
+++ b/test_plans/perf_virtio_user_loopback_test_plan.rst
@@ -290,3 +290,31 @@ Test Case 9: loopback test with split ring inorder non-mergeable path
 4. Repeat below command to get throughput 10 times,then check the average throughput can get expected data with below command::
 
     testpmd>show port stats all
+
+Test Case 10: loopback test with packed ring vectorized path
+============================================================
+
+1. Launch vhost by below command::
+
+    rm -rf vhost-net*
+    ./testpmd -n 4 -l 2-4  --no-pci \
+    --file-prefix=vhost --vdev 'net_vhost0,iface=vhost-net,queues=1,client=0' -- -i --nb-cores=1 --txd=1024 --rxd=1024
+    testpmd>set fwd mac
+
+2. Launch virtio-user by below command::
+
+    ./testpmd -n 4 -l 5-6 \
+    --no-pci --file-prefix=virtio --force-max-simd-bitwidth=512 \
+    --vdev=net_virtio_user0,mac=00:01:02:03:04:05,path=./vhost-net,packed_vq=1,in_order=1,mrg_rxbuf=0,vectorized=1 \
+    -- -i --rss-ip --nb-cores=1 --txd=1024 --rxd=1024
+    >set fwd mac
+    >start
+
+3. Send packets with vhost-testpmd,[frame_size] is the parameter changs in [64, 1518]::
+
+    testpmd>set txpkts [frame_size]
+    testpmd>start tx_first 32
+
+4. Repeat below command to get throughput 10 times,then check the average throughput can get expected data with below command::
+
+    testpmd>show port stats all