diff --git a/test_plans/cvl_advanced_iavf_rss_test_plan.rst b/test_plans/cvl_advanced_iavf_rss_test_plan.rst
index ad2976a3..c4661550 100644
--- a/test_plans/cvl_advanced_iavf_rss_test_plan.rst
+++ b/test_plans/cvl_advanced_iavf_rss_test_plan.rst
@@ -70,74 +70,74 @@ Pattern and input set
     | IPv4/IPv6 + TCP/UDP/SCTP      | MAC_IPV4                  | eth, l2-src-only, l2-dst-only, ipv4, l3-src-only, l3-dst-only                    |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV4_UDP              | eth, l2-src-only, l2-dst-only, ipv4-udp, l3-src-only, l3-dst-only,               |
-    |                               |                           | l4-src-only, l4-dst-only                                                         |
+    |                               |                           | l4-src-only, l4-dst-only, ipv4                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV4_TCP              | eth, l2-src-only, l2-dst-only, ipv4-tcp, l3-src-only, l3-dst-only,               |
-    |                               |                           | l4-src-only, l4-dst-only                                                         |
+    |                               |                           | l4-src-only, l4-dst-only, ipv4                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV4_SCTP             | eth, l2-src-only, l2-dst-only, ipv4-sctp, l3-src-only, l3-dst-only,              |
-    |                               |                           | l4-src-only, l4-dst-only                                                         |
+    |                               |                           | l4-src-only, l4-dst-only, ipv4                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6                  | eth, l2-src-only, l2-dst-only, ipv6, l3-src-only, l3-dst-only                    |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6_UDP              | eth, l2-src-only, l2-dst-only, ipv6-udp, l3-src-only, l3-dst-only,               |
-    |                               |                           | l4-src-only, l4-dst-only                                                         |
+    |                               |                           | l4-src-only, l4-dst-only, ipv6                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6_TCP              | eth, l2-src-only, l2-dst-only, ipv6-tcp, l3-src-only, l3-dst-only,               |
-    |                               |                           | l4-src-only, l4-dst-only                                                         |
+    |                               |                           | l4-src-only, l4-dst-only, ipv6                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6_SCTP             | eth, l2-src-only, l2-dst-only, ipv6-sctp, l3-src-only, l3-dst-only,              |
-    |                               |                           | l4-src-only, l4-dst-only                                                         |
+    |                               |                           | l4-src-only, l4-dst-only, ipv6                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     | GTP-U data packet types       | MAC_IPV4_GTPU_IPV4        | gtpu, ipv4, l3-src-only, l3-dst-only                                             |
     | IPv4/IPv6 transport           |                           |                                                                                  |
     | IPv4/IPv6 payload             |                           |                                                                                  |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_IPV4_UDP    | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_IPV4_UDP    | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_IPV4_TCP    | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_IPV4_TCP    | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV4_GTPU_IPV6        | gtpu, ipv6, l3-src-only, l3-dst-only                                             |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_IPV6_UDP    | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_IPV6_UDP    | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_IPV6_TCP    | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_IPV6_TCP    | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6_GTPU_IPV4        | gtpu, ipv4, l3-src-only, l3-dst-only                                             |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_IPV4_UDP    | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_IPV4_UDP    | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_IPV4_TCP    | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_IPV4_TCP    | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6_GTPU_IPV6        | gtpu, ipv6, l3-src-only, l3-dst-only                                             |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_IPV6_UDP    | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_IPV6_UDP    | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_IPV6_TCP    | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_IPV6_TCP    | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV4_GTPU_EH_IPV4     | ipv4, l3-src-only, l3-dst-only                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_EH_IPV4_UDP | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_EH_IPV4_UDP | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_EH_IPV4_TCP | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_EH_IPV4_TCP | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV4_GTPU_EH_IPV6     | ipv6, l3-src-only, l3-dst-only                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_EH_IPV6_UDP | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_EH_IPV6_UDP | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV4_GTPU_EH_IPV6_TCP | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV4_GTPU_EH_IPV6_TCP | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6_GTPU_EH_IPV4     | ipv4, l3-src-only, l3-dst-only                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_EH_IPV4_UDP | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_EH_IPV4_UDP | ipv4-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_EH_IPV4_TCP | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_EH_IPV4_TCP | ipv4-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv4               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     |                               | MAC_IPV6_GTPU_EH_IPV6     | ipv6, l3-src-only, l3-dst-only                                                   |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_EH_IPV6_UDP | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_EH_IPV6_UDP | ipv6-udp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
-    |                               | MAC_IPV6_GTPU_EH_IPV6_TCP | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only                     |
+    |                               | MAC_IPV6_GTPU_EH_IPV6_TCP | ipv6-tcp, l3-src-only, l3-dst-only, l4-src-only, l4-dst-only, ipv6               |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
     | VLAN                          | MAC_VLAN_IPV4             | c-vlan                                                                           |
     +-------------------------------+---------------------------+----------------------------------------------------------------------------------+
@@ -772,6 +772,23 @@ ipv4-udp packets::
 
     sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E1")/IP(dst="192.168.1.1", src="192.168.1.2")/UDP(sport=32,dport=23)/("X"*480)],iface="enp134s0f0")
 
+Subcase: MAC_IPV4_UDP_IPV4
+--------------------------
+1. create rss rule::
+
+    flow create 0 ingress pattern eth / ipv4 / udp / end actions rss types ipv4 end key_len 0 queues end / end
+
+2. hit pattern/defined input set:
+ipv4-udp packets::
+
+    sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E0")/IP(dst="192.168.1.1", src="192.168.0.2")/UDP(sport=22,dport=23)/("X"*480)],iface="enp134s0f0")
+    sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E0")/IP(dst="192.168.0.1", src="192.168.1.2")/UDP(sport=22,dport=23)/("X"*480)],iface="enp134s0f0")
+
+3. hit pattern/not defined input set:
+ipv4-udp packets::
+
+    sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E1")/IP(dst="192.168.0.1", src="192.168.0.2")/UDP(sport=32,dport=33)/("X"*480)],iface="enp134s0f0")
+
 Subcase: MAC_IPV4_UDP_ALL
 -------------------------
 1. create rss rule::
@@ -838,6 +855,9 @@ Subcase: MAC_IPV4_TCP_L4SRC
 Subcase: MAC_IPV4_TCP_L4DST
 ---------------------------
 
+Subcase: MAC_IPV4_TCP_IPV4
+--------------------------
+
 Subcase: MAC_IPV4_TCP_ALL
 -------------------------
 
@@ -887,6 +907,9 @@ Subcase: MAC_IPV4_SCTP_L4SRC
 Subcase: MAC_IPV4_SCTP_L4DST
 ----------------------------
 
+Subcase: MAC_IPV4_SCTP_IPV4
+---------------------------
+
 Subcase: MAC_IPV4_SCTP_ALL
 --------------------------
 
@@ -1320,6 +1343,23 @@ ipv6-udp packets::
 
     sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E1")/IPv6(src="ABAB:910B:6666:3457:8295:3333:1800:2928",dst="CDCD:910A:2222:5498:8475:1111:3900:2021")/UDP(sport=32,dport=23)/("X"*480)],iface="enp134s0f0")
 
+Subcase: MAC_IPV6_UDP_IPV6
+--------------------------
+1. create rss rule::
+
+    flow create 0 ingress pattern eth / ipv6 / udp / end actions rss types ipv6 end key_len 0 queues end / end
+
+2. hit pattern/defined input set:
+ipv6-udp packets::
+
+    sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E0")/IPv6(src="ABAB:910B:6666:3457:8295:3333:1800:2928",dst="CDCD:910A:2222:5498:8475:1111:3900:2020")/UDP(sport=22,dport=23)/("X"*480)],iface="enp134s0f0")
+    sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E0")/IPv6(src="ABAB:910B:6666:3457:8295:3333:1800:2929",dst="CDCD:910A:2222:5498:8475:1111:3900:2021")/UDP(sport=22,dport=23)/("X"*480)],iface="enp134s0f0")
+
+3. hit pattern/not defined input set:
+ipv6-udp packets::
+
+    sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E1")/IPv6(src="ABAB:910B:6666:3457:8295:3333:1800:2929",dst="CDCD:910A:2222:5498:8475:1111:3900:2020")/UDP(sport=32,dport=33)/("X"*480)],iface="enp134s0f0")
+
 Subcase: MAC_IPV6_UDP_ALL
 -------------------------
 1. create rss rule::
@@ -1339,6 +1379,7 @@ ipv6-udp packets::
 
     sendp([Ether(dst="00:11:22:33:44:55", src="68:05:CA:BB:26:E1")/IPv6(src="ABAB:910B:6666:3457:8295:3333:1800:2929",dst="CDCD:910A:2222:5498:8475:1111:3900:2020")/UDP(sport=22,dport=23)/("X"*480)],iface="enp134s0f0")
 
+
 Test case: MAC_IPV6_TCP
 =======================
 the rules and packets in this test case is similar to "Test case: MAC_IPV6_UDP"
@@ -1385,6 +1426,9 @@ Subcase: MAC_IPV6_TCP_L4SRC
 Subcase: MAC_IPV6_TCP_L4DST
 ---------------------------
 
+Subcase: MAC_IPV6_TCP_IPV6
+--------------------------
+
 Subcase: MAC_IPV6_TCP_ALL
 -------------------------
 
@@ -1434,6 +1478,9 @@ Subcase: MAC_IPV6_SCTP_L4SRC
 Subcase: MAC_IPV6_SCTP_L4DST
 ----------------------------
 
+Subcase: MAC_IPV6_SCTP_IPV6
+---------------------------
+
 Subcase: MAC_IPV6_SCTP_ALL
 --------------------------
 
@@ -1655,9 +1702,6 @@ Test Case: negative case
     testpmd> flow create 0 ingress pattern eth / ipv4 / end actions rss types ipv4-udp end key_len 0 queues end / end
     ice_flow_create(): Failed to create flow
     port_flow_complain(): Caught PMD error type 10 (item specification): cause: 0x7fff3b61eb08, Invalid input set: Invalid argument
-    testpmd> flow create 0 ingress pattern eth / ipv4 / udp / end actions rss types ipv4 end key_len 0 queues end / end
-    ice_flow_create(): Failed to create flow
-    port_flow_complain(): Caught PMD error type 10 (item specification): cause: 0x7fff3b61eb08, Invalid input set: Invalid argument
     testpmd> flow create 0 ingress pattern eth / ipv4 / udp / end actions rss types ipv4-tcp end key_len 0 queues end / end
     ice_flow_create(): Failed to create flow
     port_flow_complain(): Caught PMD error type 10 (item specification): cause: 0x7fff3b61eb08, Invalid input set: Invalid argument
@@ -1667,9 +1711,6 @@ Test Case: negative case
     testpmd> flow create 0 ingress pattern eth / ipv4 / end actions rss func symmetric_toeplitz types ipv4 l3-src-only end key_len 0 queues end / end
     ice_flow_create(): Failed to create flow
     port_flow_complain(): Caught PMD error type 10 (item specification): cause: 0x7fff3b61eb08, Invalid input set: Invalid argument
-    testpmd> flow create 0 ingress pattern eth / ipv4 / end actions rss func symmetric_toeplitz types eth end key_len 0 queues end / end
-    ice_flow_create(): Failed to create flow
-    port_flow_complain(): Caught PMD error type 10 (item specification): cause: 0x7fff3b61eb08, Invalid input set: Invalid argument
 
    check all the rule failed to be created.
 